package com.fjhx.enums;

import com.fjhx.service.Operation;
import com.fjhx.service.impl.TcpOperation;
import com.fjhx.service.impl.UdpOperation;
import lombok.Getter;

import java.util.HashMap;

/**
 * 入库类型
 */
@Getter
public enum AgreementEnum {

    TCP(1),
    UDP(2);

    private final Integer type;

    private static final HashMap<Integer, AgreementEnum> map = new HashMap<>();

    AgreementEnum(Integer type) {
        this.type = type;
    }

    static {
        for (AgreementEnum value : AgreementEnum.values()) {
            map.put(value.getType(), value);
        }
    }

    public Operation getOperation() {
        switch (this) {
            case TCP:
                return new TcpOperation();
            case UDP:
                return new UdpOperation();
        }
        return null;
    }

    /**
     * 根据type获取枚举
     */
    public static AgreementEnum get(Integer type) {
        return map.get(type);
    }

}
