package com.fjhx.utils;

import com.alibaba.fastjson.JSONObject;
import com.fjhx.MyMain;
import com.fjhx.entity.MessageEntity;
import org.java_websocket.client.WebSocketClient;
import org.java_websocket.handshake.ServerHandshake;

import java.net.URI;
import java.net.URISyntaxException;

public class BaseWebSocketClient extends WebSocketClient {

    public BaseWebSocketClient(URI serverUri) {
        super(serverUri);
    }

    @Override
    public void onOpen(ServerHandshake serverHandshake) {
        MyUtil.infoLog("连接成功...");
    }

    @Override
    public void onMessage(String str) {
        MyUtil.infoLog(str);
        MessageEntity messageEntity = JSONObject.parseObject(str, MessageEntity.class);
        MyMain.service.handleMessage(messageEntity);
    }

    @Override
    public void onClose(int i, String s, boolean b) {
        MyUtil.errorLog("连接断开...");
        MyUtil.sleep(5 * 1000);
        MyUtil.infoLog("尝试重连...");
        MyMain.connectWebSocket();
    }

    @Override
    public void onError(Exception e) {

    }

    /**
     * 获取webSocketClient
     */
    public static BaseWebSocketClient init(String url) throws URISyntaxException {
        return new BaseWebSocketClient(new URI(url));
    }

}
